package com.bofeng.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.google.common.base.Strings;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

@Getter
@Setter
public class ExcelRiBao {

    private String ridgepole;
    private String unit;
    private String doorplate;
    private int grender;
    private int familyStatus;
    private int medical;
    private BigDecimal temperature;
    private int cough;
    private int muscle;
    private int dyspnea;
    private int fatigue;
    private int diarrhea;
    private int singleRoom;
    private String statusDesp = "";
    private String others = "";


    @ExcelProperty(value = "楼栋", index = 0)
    private String loudong = "";

    public String getLoudong() {
        if (loudong.length() <= 0) {
            loudong = ridgepole + "栋" + unit + "单元";
        }
        return loudong;
    }

    @ExcelProperty(value = "房号", index = 1)
    private String fanghao = "";

    public String getFanghao() {
        if (fanghao.length() <= 0) {
            fanghao = doorplate;
        }
        return fanghao;
    }

    @ExcelProperty(value = "联系人", index = 2)
    private String linkman;

    @ExcelProperty(value = "联系电话", index = 3)
    private String phone;

    @ExcelProperty(value = "今日居家人数", index = 4)
    private int safetyNum;

    @ExcelProperty(value = "确诊入院人数", index = 5)
    private int sureNum;

    @ExcelProperty(value = "隔离人数", index = 6)
    private int singleNum;

    @ExcelProperty(value = "异常观察人数", index = 7)
    private int suspectedNum;

    @ExcelProperty(value = "身体正常人数", index = 8)
    private int normalNum;

    @ExcelProperty(value = "居家人员姓名", index = 9)
    private String userName;

    @ExcelProperty(value = "性别", index = 10)
    private String grenderStr;

    public String getGrenderStr() {
        if (grender == 1) {
            grenderStr = "男";
        } else if (grender == 2) {
            grenderStr = "女";
        } else {
            grenderStr = "未知";
        }
        return grenderStr;
    }

    @ExcelProperty(value = "年龄", index = 11)
    private String age;

    @ExcelProperty(value = "身体基本情况", index = 12)
    private String baseDesc;
    public String getBaseDesc() {
        if (familyStatus == 0) {
            baseDesc = "无病史";
        } else if (familyStatus == 1) {
            baseDesc = "心血管疾病（服用ARB）";
        } else if (familyStatus == 2) {
            baseDesc = "心血管疾病（未服用ARB）";
        } else if (familyStatus == 3) {
            baseDesc = "呼吸系统病史";
        } else if (familyStatus == 4) {
            baseDesc = "肿瘤病史";
        } else if (familyStatus == 5) {
            baseDesc = "糖尿病史";
        } else if (familyStatus == 6) {
            baseDesc = "服用过激素药物";
        } else if (familyStatus == 7) {
            baseDesc = "妊娠期";
        } else {
            baseDesc = "其他";
        }
        return baseDesc;
    }

    @ExcelProperty(value = "病情描述", index = 13)
    private String bingqingDesc = "";
    public String getBingqingDesc() {

        if (cough == 1) {
            bingqingDesc += "偶尔短暂咳嗽、";
        } else if (cough == 2) {
            bingqingDesc += "咳嗽轻度影响生活、";
        } else if (cough == 3) {
            bingqingDesc += "咳嗽严重影响生活、";
        }
        if (muscle == 1) {
            bingqingDesc += "肌肉按压有酸痛、";
        } else if (muscle == 2) {
            bingqingDesc += "偶尔肌肉按压酸痛、";
        } else if (muscle == 3) {
            bingqingDesc += "肌肉按压持续酸痛、";
        }
        if (dyspnea == 1) {
            bingqingDesc += "呼吸急走或上坡气短、";
        } else if (dyspnea == 2) {
            bingqingDesc += "呼吸气短而走路变慢、";
        } else if (dyspnea == 3) {
            bingqingDesc += "呼吸走路数分钟后气短、";
        } else if (dyspnea == 4) {
            bingqingDesc += "呼吸气短无法离开房间、";
        }
        if (fatigue == 1) {
            bingqingDesc += "可体力劳动但觉得累、";
        } else if (fatigue == 2) {
            bingqingDesc += "轻体力劳动后长时间不能恢复、";
        } else if (fatigue == 3) {
            bingqingDesc += "不能正常生活、";
        }
        if (diarrhea == 1) {
            bingqingDesc += "轻度腹泻少于于3次、";
        } else if (diarrhea == 2) {
            bingqingDesc += "中度腹泻4-6次、";
        } else if (diarrhea == 3) {
            bingqingDesc += "重度腹泻超过6次、";
        }
        if (singleRoom == 1) {
            bingqingDesc += "单间隔离、";
        }
        if (!Strings.isNullOrEmpty(statusDesp)) {
            bingqingDesc += statusDesp;
            bingqingDesc += "、";
        }
        if (!Strings.isNullOrEmpty(others)) {
            bingqingDesc += others;
        }
        return bingqingDesc;
    }
}
