package com.bofeng.wx.controller;


import com.bofeng.entity.*;
import com.bofeng.service.MsReportService;
import com.bofeng.service.MsSuspectedService;
import com.yvan.Model;
import com.yvan.ModelOps;
import com.yvan.mvc.Pd;
import com.yvan.platform.Conv;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

/**
 * @Author: xielianghe
 * @Date: 2020/2/4 15:38
 */
@RestController
public class MsReportController {

    @Autowired
    private MsSuspectedService msSuspectedService;
    @Autowired
    private MsReportService msReportService;

    //添加家人
    @PostMapping("/home/addRibao")
    public MsReport saveUser(HttpServletRequest request) {
        //初始化今日日报
        Long suspectedId = Conv.NL(request.getParameter("suspectedId"));
        Long userCreate = Conv.NL(request.getParameter("userCreate"));
        String userName = request.getParameter("userName");
        Integer grender = Conv.NI(request.getParameter("grender"));
        Integer age = Conv.NI(request.getParameter("age"));
        Integer familyStatus = Conv.NI(request.getParameter("familyStatus"));
        String statusDesp = request.getParameter("statusDesp");
        Integer medical = Conv.NI(request.getParameter("medical"));
        BigDecimal temperature = new BigDecimal(request.getParameter("temperature"));
        Integer cough = Conv.NI(request.getParameter("cough"));
        Integer muscle = Conv.NI(request.getParameter("muscle"));
        Integer dyspnea = Conv.NI(request.getParameter("dyspnea"));
        Integer fatigue = Conv.NI(request.getParameter("fatigue"));
        Integer diarrhea = Conv.NI(request.getParameter("diarrhea"));
        Integer singleRoom = Conv.NI(request.getParameter("singleRoom"));
        String others = request.getParameter("others");
        Long reportId =msSuspectedService.addSuspected(suspectedId, userName, grender, age, familyStatus, statusDesp, medical, temperature, cough, muscle, dyspnea, fatigue, diarrhea, singleRoom, others, userCreate);

        return msReportService.getByReport(reportId);
    }

    //查询家人
    @GetMapping("/home/selectSuspected")
    public MsSuspected selectSuspected(HttpServletRequest request) {
        //初始化今日日报
        Long suspectedId = Long.parseLong(request.getParameter("suspectedId"));
        return msSuspectedService.selectSuspected(suspectedId);
    }

    //删除家人病例
    @PostMapping("/home/deleteSuspected")
    public MsReport deleteSuspected(HttpServletRequest request) {
        Long suspectedId = Long.parseLong(request.getParameter("suspectedId"));
        MsSuspected msSuspected = msSuspectedService.selectSuspected(suspectedId);
        msSuspectedService.deleteSuspected(suspectedId);
        if (msSuspected != null)
            return msReportService.getByReport(msSuspected.getReportId());
        else
            return null;
    }

    //根据登录人获取家人
    @GetMapping("/home/home/queryRibao")
    public Model<List<MsSuspected>> queryRibao(@Pd(name = "userCreate") Long userCreate) {
        Date t = new Date();
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
        String reportDate = df.format(t);
        return Model.newSuccess(msReportService.getByReportReportDate(reportDate, userCreate));
    }

    //根据日报获取家人
    @GetMapping("/home/home/queryRibaoRefresh")
    public Model<List<MsSuspected>> queryRibaoRefresh(@Pd(name = "reportId") Long reportId) {
        return Model.newSuccess(msReportService.getByReportId(reportId));
    }

    //全家报平安
    @PostMapping("/home/addReport")
    public ModelOps addReport(HttpServletRequest request) {
        Long userCreate = Long.parseLong(request.getParameter("userCreate"));
        int re = msReportService.addReport(userCreate);
        if (re == 1) {
            return ModelOps.newSuccess();
        } else if (re == 2) { //没有上报体温
            return ModelOps.newFail("请填报今日体温！");
        }else if (re == 3) { //没有选择家人
            return ModelOps.newFail("请选择家人！");
        }
        return ModelOps.newFail("上报错误");
    }

    //根据日期获取家人
    @GetMapping("/home/home/queryRibaoReportDate")
    public Model<List<MsSuspected>> queryRibaoReportDate(@Pd(name = "reportDate") String reportDate, @Pd(name = "userCreate") Long userCreate) {
        return Model.newSuccess(msReportService.getByReportReportDate(reportDate, userCreate));
    }

    //通过昨天数据更新今天数据
    @PostMapping("/home/getNowByYesterday")
    public Integer getNowByYesterday(HttpServletRequest request) {
        Long userCreate = Long.parseLong(request.getParameter("userCreate"));
        msReportService.getNowByYesterday(userCreate);
        return 1;
    }
}
